/*
Sandbox Feeling v0.1b
Melih SARICA
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <windows.h>
#include <shlobj.h>
#include <io.h>

int main()
{
    int d, i;
    char log_file[64], c;
    char program_path[MAX_PATH + 1], system_path[MAX_PATH + 1], path[MAX_PATH + 1];
    FILE *f, *ff;
    char *fake_files[]={"vboxsf.sys", "vboxnetadp.sys", "vmci.sys", "vmhgfs.sys", "vmmouse.sys", "vmscsi.sys", "vmusbmouse.sys", "vmx_svga.sys", "vmxnet.sys", "vboxmouse.sys", NULL};
    static HMODULE kernel32handle;
    typedef WINBOOL (__stdcall (*rd))(PVOID *);
    static rd rdf;
    static PVOID r;

    kernel32handle = GetModuleHandleW(L"kernel32.dll"); /*missing in gcc headers*/
    rdf = (rd)GetProcAddress(kernel32handle, "Wow64DisableWow64FsRedirection");
    if(rdf != NULL) rdf(&r);

    snprintf(log_file, sizeof(log_file) - 1, "Log-%ld.txt", time(NULL));
    printf("SandboxFeeling v1.0b - // Melih SARICA\n");
    printf("Changes will be written to %s\nContinue? (y/N)", log_file);
    /*if(!IsUserAnAdmin())
    {
        printf("You need administrative privileges!\n");
        return -1;
    }*/
    c = getchar();
    if(c != 'Y' && c != 'y')
    {
        printf("Cancelled.\n");
        return -1;
    }

    if(!GetEnvironmentVariable("ProgramW6432", program_path, sizeof(program_path) - 1))
    {
        if(!GetEnvironmentVariable("ProgramFiles", program_path, sizeof(program_path) - 1))
        {
            printf("Error getting program files directory.\n");
            return -2;
        }
    }

    if(SHGetFolderPath(NULL, CSIDL_SYSTEM, NULL, 0, system_path) != S_OK)   /*TODO: utf8 dir names*/
    {
        printf("Error getting system directory.\n");
        return -3;
    }

    f = fopen(log_file, "a+t");
    if(f == NULL)
    {
        printf("Couldn't create log file. Exiting...\n");
        return -4;
    }

    snprintf(path, sizeof(path) - 1, "%s\\Oracle\\VirtualBox Guest Additions", program_path);
    d = GetFileAttributes(path);
    if(d != INVALID_FILE_ATTRIBUTES && (d & FILE_ATTRIBUTE_DIRECTORY))
    {
        printf("Path already exists, skipping...\n");
    }
    else
    {
        printf("Creating path: %s\n", path);
        if(CreateDirectory(path, NULL))
        {
            printf("Path created. Logging...\n");
            fprintf(f, "Directory created: %s\n", path);
        }
        else printf("Couldn't create path. Permissions?\n");
    }

    for(i = 0; fake_files[i] != NULL; i++)
    {
        snprintf(path, sizeof(path) - 1, "%s\\drivers\\%s", system_path, fake_files[i]);
        if(_access(path, 0) == 0)
        {
            printf("File already exists. Skipping: %s\n", path);
            continue;
        }
        else
        {
            printf("File not exists so creating one: %s\n", path);
            ff = fopen(path, "w+t");
            if(ff != NULL)
            {
                fprintf(ff, "%s", path); /*write some junk*/
                fclose(ff);
                fprintf(f, "File created: %s\n", path);
            }
            else printf("Couldn't create file. Permissions?\n");
        }
    }



    fclose(f);
    printf("Completed.\n");
    getchar();getchar();

    return 0;
}
